###################################################
### chunk number 1: randtree1
###################################################
#line 71 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
library(ape)
set.seed(1)  ## set random-number seed
rand_tree <- rcoal(10) ## Make a random tree with 10 tips
plot(rand_tree)


###################################################
### chunk number 2: convtree
###################################################
#line 82 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
library(phylobase)
# convert rand_tree to a phylo4 object
rand_p4_tree <- as(rand_tree, "phylo4")
plot(rand_p4_tree)


###################################################
### chunk number 3: doc0 eval=FALSE
###################################################
## #line 91 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## ?plot(rand_p4_tree)


###################################################
### chunk number 4: doc1 eval=FALSE
###################################################
## #line 97 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## method?plot("phylo4")


###################################################
### chunk number 5: doc2 eval=FALSE
###################################################
## #line 103 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## help('Documentation', package="methods")


###################################################
### chunk number 6: geodata
###################################################
#line 112 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
library(phylobase)
data(geospiza_raw)
## what does it contain?
names(geospiza_raw)


###################################################
### chunk number 7: convgeodata
###################################################
#line 120 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
(g1 <- as(geospiza_raw$tree, "phylo4"))


###################################################
### chunk number 8: nodelabelgeodata
###################################################
#line 127 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
nodeLabels(g1)


###################################################
### chunk number 9: 
###################################################
#line 135 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
nodeLabels(g1) <- paste("N", nodeId(g1, "internal"), sep="")
head(g1, 5)


###################################################
### chunk number 10: sumgeodata
###################################################
#line 142 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
summary(g1)


###################################################
### chunk number 11: tiplabelgeodata
###################################################
#line 147 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
tipLabels(g1)


###################################################
### chunk number 12: nodenumbergeodata
###################################################
#line 154 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
nodeId(g1, type='all')


###################################################
### chunk number 13: edgelabelgeodata
###################################################
#line 160 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
edgeLabels(g1)


###################################################
### chunk number 14: rootedgeodata
###################################################
#line 165 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
isRooted(g1)


###################################################
### chunk number 15: rootnodegeodata
###################################################
#line 170 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
rootNode(g1)


###################################################
### chunk number 16: polygeodata
###################################################
#line 175 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
hasPoly(g1)


###################################################
### chunk number 17: hasbrlengeodata
###################################################
#line 180 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
hasEdgeLength(g1)


###################################################
### chunk number 18: modlabelsgeodata
###################################################
#line 186 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
tipLabels(g1) <- tolower(tipLabels(g1))


###################################################
### chunk number 19:  eval=FALSE
###################################################
## #line 192 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## tipLabels(g1)[c(11, 13)] <- c("platyspiza", "pinaroloxias")


###################################################
### chunk number 20: geomergedata eval=FALSE
###################################################
## #line 202 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## g2 <- phylo4d(g1, geospiza_raw$data)


###################################################
### chunk number 21: geomergeerr1
###################################################
#line 206 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
g2 <- try(phylo4d(g1, geospiza_raw$data),silent=TRUE)
cat(as.character(g2))


###################################################
### chunk number 22: geomergenames
###################################################
#line 213 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
gdata <- geospiza_raw$data
row.names(gdata) <- tolower(row.names(gdata))


###################################################
### chunk number 23: geomerge2
###################################################
#line 220 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
g2 <- phylo4d(g1, gdata, missing.data="warn")


###################################################
### chunk number 24: geomerge3
###################################################
#line 226 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
g1B <- prune(g1, "olivacea")
phylo4d(g1B, gdata)


###################################################
### chunk number 25: geomergesum
###################################################
#line 232 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
summary(g2)


###################################################
### chunk number 26: geoextract
###################################################
#line 253 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
subset(g2, tips.include=c("fuliginosa", "fortis", "magnirostris",
            "conirostris", "scandens"))
subset(g2, node.subtree=21)
subset(g2, mrca=c("scandens", "fortis"))


###################################################
### chunk number 27: geodrop
###################################################
#line 261 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
try(
subset(g2, tips.exclude=c("fuliginosa", "fortis", "magnirostris",
            "conirostris", "scandens"))
    , silent=TRUE)
try(
subset(g2, tips.exclude=names(descendants(g2 ,MRCA(g2, c("difficilis", "fortis")))))
    , silent=TRUE)


###################################################
### chunk number 28: rtree2
###################################################
#line 305 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
set.seed(1001)
tree <- as(rcoal(12), "phylo4")


###################################################
### chunk number 29: vcvphylo
###################################################
#line 312 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
vmat <- as(tree, "phylo4vcov")
vmat <- cov2cor(vmat)
library(MASS)
trvec <- mvrnorm(1, mu=rep(0, 12), Sigma=vmat)


###################################################
### chunk number 30: plotvcvphylo
###################################################
#line 321 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
treed <- phylo4d(tree, tip.data=as.data.frame(trvec))
plot(treed)


###################################################
### chunk number 31: 
###################################################
#line 328 "d:/temp/RtmpIxJGvH/R.INSTALL44f125d4/phylobase/inst/doc/phylobase.Rnw"
## add node labels so we can match to data
nodeLabels(tree) <- as.character(nodeId(tree, "internal"))
## ordering will make sure that we have ancestor value
## defined before descendant
tree <- reorder(tree, "preorder")
edgemat <- edges(tree)
## set aside space for values
nodevals <- numeric(nrow(edgemat))
## label data in edge matrix order
names(nodevals) <- labels(tree, "all")[nodeId(tree, "all")]
## variance is proportional to edge length; drop first
## element of edge length, which is NA
dvals <- rnorm(nrow(edgemat) - 1, sd=edgeLength(tree)[-1]^2)
## indexing: ind[node number] gives position in edge matrix
ind <- order(nodeId(tree, "all"))
for (i in 2:nrow(edgemat)) {
  ## value of ancestor node plus change
  nodevals[i] <- nodevals[ind[edgemat[i, 1]]] + dvals[i - 1]
  }
nodevals <- data.frame(nodevals)
treed2 <- phylo4d(tree, all.data=nodevals)


